unit arithmTerme1_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,adt;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    SyntaxCheckBtn: TButton;
    RechneBtn: TButton;
    Edit2: TEdit;
    ResetBtn: TButton;
    ComboBox1: TComboBox;
    procedure Showstack;
    procedure rechne;
    procedure Init;
    procedure AktualisiereAnzeige;
    procedure FormCreate(Sender: TObject);
    procedure SyntaxCheckBtnClick(Sender: TObject);
    procedure RechneBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

TDaten = string;
PDaten = ^TDaten;


var
  Form1: TForm1;
  stack1 : TSTack;
  pos,e,z : integer;
  s,s0 : string;

implementation

{$R *.DFM}

procedure TForm1.Init;
begin
Stack1 := TStack.Create; Stack1.Init(100);
e := 0; z := 0; pos := 0;
with ComboBox1 do begin
  s := Text;
  SelStart := pos; SelLength := 1;
end;
Listbox1.Clear; Edit2.Text := s;
end;

procedure TForm1.AktualisiereAnzeige;
begin
  Edit2.Text := s; inc(pos);
  ShowStack;
  ComboBox1.SelStart := pos;
  ComboBox1.SelLength := 1;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
init;
s := ComboBox1.Items[0]; ComboBox1.Text := s;
end;

procedure TForm1.Showstack;
var n : integer;
    dptr : PDaten;
begin
ListBox1.Items.Clear;
if Stack1.Count > 0 then
for n := 0 to Stack1.count-1 do begin
  dptr:= Stack1.Items[n];
  if dptr <> NIL then ListBox1.Items.Add(dptr^);
end;
end;


procedure TForm1.SyntaxCheckBtnClick(Sender: TObject);
var c : char;
    dptr : PDaten;
begin
if (length(s) > 0)  then begin
  c := s[1]; new(dptr); dptr^ :=  c;
  if c = '(' then Stack1.Push(dptr);
  if c = ')' then Stack1.Pop;
  delete(s,1,1);
  AktualisiereAnzeige;
end;
if (length(s) = 0) and Stack1.Empty then begin
  Edit2.Text := 'ok';
  exit;
end;
if (length(s) = 0) and not Stack1.Empty then  begin
  Edit2.Text := 'zu viele ffnende Klammern';
  exit;
end;
if (length(s) > 0) and Stack1.Empty then  begin
  Edit2.Text := 'zu viele schlieende Klammern';
  exit;
end;
end;


procedure Tform1.Rechne;
var zs,rz : string;
    e,z1,z2: integer;
    dptr : PDaten;
begin
dptr := stack1.top; zs := dptr^;
z1 := StrToInt(zs); dispose(dptr); stack1.pop;
dptr := stack1.top; rz := dptr^;
dispose(dptr); stack1.pop;
dptr := stack1.top; zs := dptr^;
z2 := StrToInt(zs); dispose(dptr); stack1.pop;
dptr := stack1.top; stack1.pop; dispose(dptr);
if rz = '+' then begin
  e := z2+z1; new(dptr);
  dptr^ := IntToStr(e);
end else
if rz = '-' then begin
  e := z2-z1; new(dptr);
  dptr^ := IntToStr(e);
end else
if rz = '*' then begin
  e := z2*z1; new(dptr);
  dptr^ := IntToStr(e);
end else
if rz = '/' then begin
  e := z2 div z1; new(dptr);
  dptr^ := IntToStr(e);
end;
Stack1.push(dptr);
end;


procedure TForm1.RechneBtnClick(Sender: TObject);
var dptr : PDaten;
    c,rz : char;
begin
if length(s) >0 then begin
  c := s[1];
  delete(s,1,1);
  case c of
  '(','0'..'9','+','-','*','/' : begin
                                     new(dptr);
                                     dptr^ := c;
                                     Stack1.push(dptr);
                                   end;
  ')'            : rechne;
  end;
  AktualisiereAnzeige;
end;
end;


procedure TForm1.ResetBtnClick(Sender: TObject);
begin
init
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
s := ComboBox1.Text;
init;
end;

end.


